# 🚧 WIP
stages:
  - 🔎code-quality
  - 🧨unit-tests
  - 🔎secure
  - 🚢k8s-deploy

#-----------------------------------------------------------------------------------------
# You can use your own tools
# > Kubectl + DSL:
#   https://gitlab.com/tanuki-workshops/kube-demos/kube-helpers
# > Testing:
#   https://gitlab.com/tanuki-workshops/kube-demos/testing-tools/mocha
# > Quality:
#   https://gitlab.com/tanuki-workshops/kube-demos/code-quality-analyzers/eslint
#   https://gitlab.com/tanuki-workshops/kube-demos/code-quality-analyzers/git-quick-stats
# > Vulnerability:
#   https://gitlab.com/tanuki-workshops/kube-demos/vulnerabilitiy-analyzers/semgrep
#   https://gitlab.com/tanuki-workshops/kube-demos/vulnerabilitiy-analyzers/gitleaks
#-----------------------------------------------------------------------------------------
include:
  - project: 'tanuki-workshops/kube-demos/kube-helpers'
    file: 'k8s.dsl.yml'
  - project: 'tanuki-workshops/kube-demos/testing-tools/mocha'
    file: 'mocha.gitlab-ci.yml'
  - project: 'tanuki-workshops/kube-demos/code-quality-analyzers/eslint'
    file: 'eslint.gitlab-ci.yml'
  - project: 'tanuki-workshops/kube-demos/code-quality-analyzers/git-quick-stats'
    file: 'git-quick-stats.gitlab-ci.yml'
  - project: 'tanuki-workshops/kube-demos/vulnerabilitiy-analyzers/semgrep'
    file: 'semgrep.gitlab-ci.yml'
  - project: 'tanuki-workshops/kube-demos/vulnerabilitiy-analyzers/gitleaks'
    file: 'gitleaks.gitlab-ci.yml'

#-----------------------------------------------------------------------------------------
# Application runtime:
#   https://gitlab.com/tanuki-workshops/kube-demos/small-faas
# Registry:
#   https://gitlab.com/tanuki-workshops/kube-demos/small-faas/container_registry  
#-----------------------------------------------------------------------------------------
variables:
  APPLICATION_IMAGE: registry.gitlab.com/tanuki-workshops/kube-demos/small-faas:latest
  FUNCTION_CODE: main.js
  FUNCTION_NAME: main
  FUNCTION_LANG: js
  CONTENT_TYPE: application/json;charset=UTF-8
  CONTAINER_PORT: 8080
  EXPOSED_PORT: 80
  REPLICAS: 1

#-----------------------------------------------------------------------------------------
# Tests report in the MR
#-----------------------------------------------------------------------------------------
🎯testing:
  stage: 🧨unit-tests
  extends: .mocha:testing
  rules:
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Quality
#-----------------------------------------------------------------------------------------
🔎:code:quality:eslint:
  stage: 🔎code-quality
  extends: .eslint:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

🤖:git-analysis:
  stage: 🔎code-quality
  extends: .git-quick-stats:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Security
#-----------------------------------------------------------------------------------------
👮‍♀️:vulnerability:detection:
  stage: 🔎secure
  extends: .semgrep:analyzer  
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

👮‍♀️:secrets:detection:
  stage: 🔎secure
  extends: .gitleaks:analyzer
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
    - if: $CI_MERGE_REQUEST_IID

#-----------------------------------------------------------------------------------------
# Deploy service to production
#-----------------------------------------------------------------------------------------
🚀:deploy:service:
  stage: 🚢k8s-deploy
  extends: .k8s:dsl
  rules:
    - if: $CI_COMMIT_BRANCH == "master"
  environment:
    name: prod/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
  script:
    - create_configmap_function
    - generate_manifest
    - apply

#-----------------------------------------------------------------------------------------
# Deploy service for review
#-----------------------------------------------------------------------------------------
🚀:deploy:reviewapp:
  stage: 🚢k8s-deploy
  extends: .k8s:dsl
  rules:
    - if:  $CI_MERGE_REQUEST_IID
  environment:
    name: review/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    url: http://${CI_PROJECT_NAME}.${CI_COMMIT_REF_SLUG}.${KUBE_INGRESS_BASE_DOMAIN}
    on_stop: ❌:remove:reviewapp
  script:
    - create_configmap_function
    - generate_manifest
    - apply

#-----------------------------------------------------------------------------------------
# Remove review service
#-----------------------------------------------------------------------------------------
❌:remove:reviewapp:
  stage: 🚢k8s-deploy
  extends: .k8s:dsl
  rules:
    - if: $CI_MERGE_REQUEST_IID
      when: manual
  allow_failure: true
  environment:
    name: review/${CI_PROJECT_NAME}-${CI_COMMIT_REF_SLUG}
    action: stop
  script:
    - delete_deployment




